DROP TABLE IF EXISTS CONTACT_GROUPS;
CREATE TABLE CONTACT_GROUPS ( 
  ID bigint(20) unsigned NOT NULL auto_increment,
  USER VARCHAR(255) NOT NULL,
  SHORT_NAME VARCHAR(100) DEFAULT '' NULL,
  DESCRIPTION VARCHAR(255) DEFAULT '' NULL,
  PRIMARY KEY (ID)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

DROP TABLE IF EXISTS CONTACT_GROUP_ITEMS;
CREATE TABLE CONTACT_GROUP_ITEMS ( 
  ID bigint(20) unsigned NOT NULL auto_increment,
  USER VARCHAR(255) NOT NULL,
  GROUP_ID BIGINT NOT NULL,
  CONTACT_ID BIGINT NOT NULL,
  PRIMARY KEY (ID)
) TYPE=MyISAM AUTO_INCREMENT=1;

DROP TABLE IF EXISTS CALENDAR_ITEMS;
CREATE TABLE IF NOT EXISTS CALENDAR_ITEMS (
  `ID` bigint(20) unsigned NOT NULL auto_increment,
  `USER` varchar(255) NOT NULL default '',
  `RECORD_DATE` timestamp(14) NOT NULL,
  `REPEAT_TYPE` int(11) NOT NULL default '0',
  `CATEGORY` varchar(255) NOT NULL default '',
  `DESCRIPTION` blob NOT NULL,
  `REMINDER_DAYS` int(11) NOT NULL default '0',
  PRIMARY KEY  (`ID`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS CONTACTS;
CREATE TABLE IF NOT EXISTS CONTACTS (
  `ID` bigint(20) unsigned NOT NULL auto_increment,
  `USER` varchar(255) default '',
  `FIRST_NAME` varchar(100) NOT NULL default '',
  `MIDDLE_NAME` varchar(100) default '',
  `LAST_NAME` varchar(100) NOT NULL default '',
  `TITLE` varchar(50) default '',
  `SEX` varchar(10) default '',
  `GSM_NO_PRIMARY` varchar(30) default '',
  `GSM_NO_ALTERNATE` varchar(30) default '',
  `EMAIL_PRIMARY` varchar(255) default '',
  `EMAIL_ALTERNATE` varchar(255) default '',
  `WEB_PAGE` varchar(255) default '',
  `PERSONAL_NOTE` blob,
  `SPOUSE_NAME` varchar(255) default '',
  `NICKNAME` varchar(50) default '',
  `BIRTHDAY` timestamp(14) NULL,
  `ANNIVERSARY` timestamp(14) NULL,
  `HOME_ADDRESS` blob,
  `HOME_CITY` varchar(255) default '',
  `HOME_PROVINCE` varchar(255) default '',
  `HOME_ZIP` varchar(5) default '',
  `HOME_COUNTRY` varchar(100) default '',
  `HOME_PHONE` varchar(30) default '',
  `HOME_FAKS` varchar(30) default '',
  `WORK_COMPANY` varchar(100) default '',
  `WORK_JOB_TITLE` varchar(100) default '',
  `WORK_DEPARTMENT` varchar(100) default '',
  `WORK_OFFICE` varchar(100) default '',
  `WORK_PROFESSION` varchar(100) default '',
  `WORK_MANAGER_NAME` varchar(255) default '',
  `WORK_ASSISTANT_NAME` varchar(255) default '',
  `WORK_ADDRESS` blob,
  `WORK_CITY` varchar(255) default '',
  `WORK_PROVINCE` varchar(255) default '',
  `WORK_ZIP` varchar(5) default '',
  `WORK_COUNTRY` varchar(100) default '',
  `WORK_PHONE` varchar(30) default '',
  `WORK_FAKS` varchar(30) default '',
  PRIMARY KEY  (`ID`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

DROP TABLE IF EXISTS EMAIL_DB_ITEMS;
CREATE TABLE IF NOT EXISTS EMAIL_DB_ITEMS (
  `ID` bigint(20) unsigned NOT NULL auto_increment,
  `USER` varchar(255) NOT NULL default '',
  `FOLDER_ID` bigint(20) unsigned NOT NULL default '0',
  `UNIQUE_ID` varchar(100) NOT NULL default '',
  `UNREAD` tinyint(1) default '0',
  `SIZE` bigint(20) unsigned NOT NULL default '0',
  `EMAIL` longblob,
  PRIMARY KEY  (`ID`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS FILTERS;
CREATE TABLE IF NOT EXISTS FILTERS (
  `ID` bigint(20) unsigned NOT NULL auto_increment,
  `USER` varchar(255) NOT NULL default '',
  `PORTION` varchar(100) default '''''',
  `CONDITION` varchar(30) default '''''',
  `KEYWORD` varchar(255) default '''''',
  `ACTION` varchar(30) default '''''',
  `DESTINATION` varchar(100) default '''''',
  PRIMARY KEY  (`ID`),
  KEY `USER` (`USER`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

DROP TABLE IF EXISTS FOLDER_DB_ITEMS;
CREATE TABLE IF NOT EXISTS FOLDER_DB_ITEMS (
  `ID` bigint(20) unsigned NOT NULL auto_increment,
  `USER` varchar(255) default NULL,
  `PARENT_ID` bigint(20) default '0',
  `FOLDER_NAME` varchar(100) NOT NULL default '',
  `TYPE` int(10) unsigned NOT NULL default '4',
  PRIMARY KEY  (`ID`),
  KEY `USER` (`USER`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

DROP TABLE IF EXISTS NOTES;
CREATE TABLE IF NOT EXISTS NOTES (
  `ID` bigint(20) unsigned NOT NULL auto_increment,
  `USER` varchar(255) NOT NULL default '',
  `FOLDER_ID` bigint(20) NOT NULL default '0',
  `NOTE` longblob,
  PRIMARY KEY  (`ID`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

DROP TABLE IF EXISTS NOTES_FOLDERS;
CREATE TABLE IF NOT EXISTS NOTES_FOLDERS (
  `ID` bigint(20) unsigned NOT NULL auto_increment,
  `USER` varchar(255) NOT NULL default '',
  `FOLDER_NAME` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`ID`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

DROP TABLE IF EXISTS USERSETTINGS;
CREATE TABLE IF NOT EXISTS USERSETTINGS (
  `ID` bigint(20) unsigned NOT NULL auto_increment,
  `USER` varchar(255) NOT NULL default '',
  `KEYWORD` varchar(255) NOT NULL default '',
  `VALUE` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`ID`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;
