-------------------------------------------------------
-- IMPORTANT: Oracle support for Oracle is not tested
-- nor it is known to be working. If you have chance to
-- evaluate it, please let me know about the results.
-- Umut Gokbayrak <umut@claros.org>
-------------------------------------------------------
drop table CONTACT_GROUPS;
CREATE TABLE CONTACT_GROUPS ( 
  ID number(20)  NOT NULL , -- auto increment
  " USER"  VARCHAR2(255) NOT NULL,
  SHORT_NAME VARCHAR2(100) DEFAULT  NULL,
  DESCRIPTION VARCHAR2(255) DEFAULT  NULL,
  PRIMARY KEY (ID));
  --------------------------------------------------------
CREATE TABLE CONTACT_GROUP_ITEMS ( 
  ID number(20) NOT NULL, -- auto increment
  "USER" VARCHAR2(255) NOT NULL,
  GROUP_ID integer NOT NULL,
  CONTACT_ID integer NOT NULL,
  PRIMARY KEY (ID))

---------------------------------------------------------
CREATE TABLE  CALENDAR_ITEMS (
  "ID" number(20) NOT NULL primary key ,
  "USER" varchar2(255)default ' '  NOT NULL ,
  "RECORD_DATE"  date  default sysdate  NOT NULL,
  "REPEAT_TYPE"  integer  default 0 NOT NULL,
  "CATEGORY"  varchar(255)default ' '  NOT NULL,
  "DESCRIPTION"  blob NOT NULL,
  "REMINDER_DAYS"  integer  default 0 NOT NULL 
)
------------------------------------------------------------

DROP TABLE IF EXISTS CONTACTS;
CREATE TABLE  CONTACTS (
  "ID" number (20)  NOT NULL primary key,
  "USER" varchar2(255) default ' ' not null,
  "FIRST_NAME" varchar2(100) default ' ' NOT NULL ,
  "MIDDLE_NAME" varchar2(100) default '',
  "LAST_NAME" varchar2(100)  default ' ' NOT NULL ,
  "TITLE" varchar2(50) default '',
  "SEX" varchar2(10) default '',
  "GSM_NO_PRIMARY" varchar2(30) default '',
  "GSM_NO_ALTERNATE" varchar2(30) default '',
  "EMAIL_PRIMARY" varchar2(255) default '',
  "EMAIL_ALTERNATE" varchar2(255) default '',
  "WEB_PAGE" varchar2(255) default '',
  "PERSONAL_NOTE" blob,
  "SPOUSE_NAME" varchar2(255) default '',
  "NICKNAME" varchar2(50) default '',
  "BIRTHDAY" date default NULL,
  "ANNIVERSARY" date  NULL,
  "HOME_ADDRESS" blob,
  "HOME_CITY" varchar2(255) default '',
  "HOME_PROVINCE" varchar2(255) default '',
  "HOME_ZIP" varchar2(5) default '',
  "HOME_COUNTRY" varchar2(100) default '',
  "HOME_PHONE" varchar2(30) default '',
  "HOME_FAKS" varchar2(30) default '',
  "WORK_COMPANY" varchar2(100) default '',
  "WORK_JOB_TITLE" varchar2(100) default '',
  "WORK_DEPARTMENT" varchar2(100) default '',
  "WORK_OFFICE" varchar2(100) default '',
  "WORK_PROFESSION" varchar2(100) default '',
  "WORK_MANAGER_NAME" varchar2(255) default '',
  "WORK_ASSISTANT_NAME" varchar2(255) default '',
  "WORK_ADDRESS" blob,
  "WORK_CITY" varchar2(255) default '',
  "WORK_PROVINCE" varchar2(255) default '',
  "WORK_ZIP" varchar2(5) default '',
  "WORK_COUNTRY" varchar2(100) default '',
  "WORK_PHONE" varchar2(30) default '',
  "WORK_FAKS" varchar2(30) default '')
------------------------------------------------------------------------------------------

DROP TABLE IF EXISTS EMAIL_DB_ITEMS;
CREATE TABLE   EMAIL_DB_ITEMS (
  "ID"  number(20) NOT NULL primary key,
  "USER" varchar2(255) default ' ' NOT NULL ,
  "FOLDER_ID" number(20)   default 0  NOT NULL ,
  "UNIQUE_ID"  varchar2(100) default ' ' NOT NULL,
  "UNREAD" integer  default 0,
  "SIZE"  integer    default 0 NOT NULL,
  "EMAIL" blob )

-------------------------------------------------------------------------------------------
DROP TABLE IF EXISTS FILTERS;
CREATE TABLE  FILTERS (
  "ID" number (20)  NOT NULL primary key,
  "USER" varchar(255) default ' 'NOT NULL ,
  "PORTION" varchar2(100) default '',
  "CONDITION" varchar2(30) default '',
  "KEYWORD" varchar2(255) default '',
  "ACTION" varchar2(30) default '',
  "DESTINATION" varchar2(100) default '')
---------------------------------------------------------------------------------------
DROP TABLE IF EXISTS FOLDER_DB_ITEMS;
CREATE TABLE FOLDER_DB_ITEMS (
 "ID" number (20)  NOT NULL primary key,
  "USER" varchar(255) default ' ' NOT NULL ,
  "PARENT_ID" number(20) default 0 ,
  "FOLDER_NAME"  varchar(100)default ' ' NOT NULL ,
  "TYPE" number(10)  default 4  NOT NULL)

--------------------------------------------------------------------------------------

DROP TABLE IF EXISTS NOTES;
CREATE TABLE  NOTES (
 "ID" number (20)  NOT NULL primary key,
  "USER"  varchar2(255)default ' '  NOT NULL ,
  "FOLDER_ID" number(20) default 0  NOT NULL ,
  "NOTE"  blob )
-----------------------------------------------------------------------------------------

DROP TABLE IF EXISTS NOTES_FOLDERS;
CREATE TABLE  NOTES_FOLDERS (
 "ID" number (20)  NOT NULL primary key,
  "USER"  varchar2(255)default ' '  NOT NULL ,
  "FOLDER_NAME"  varchar2(255) default ' ' NOT NULL)
--------------------------------------------------------------------------------------
DROP TABLE IF EXISTS USERSETTINGS;
CREATE TABLE  USERSETTINGS (
 "ID" number (20)  NOT NULL primary key,
  "USER"  varchar2(255)default ' '  NOT NULL ,
  "KEYWORD"  varchar2(255)  default ' 'NOT NULL ,
  "VALUE"  varchar2(255) default ' 'NOT NULL)

--------------------------------------------------------------------------------
Sequence and trigger script:
-------------------------------
create sequence seq_CONTACT_GROUPS;
create trigger t_trigger_CONTACT_GROUPS  before insert on CONTACT_GROUPS for each row
begin
   if ( :new.id is null ) then
      select seq_CONTACT_GROUPS.nextval into :new.id from dual;
   end if;
end;


----------------------------------------------------------------------------------------------------------------
create sequence seq_CONTACT_GROUP_ITEMS;
create trigger t_trigger_CONTACT_GROUP_ITEMS  before insert on CONTACT_GROUP_ITEMS for each row
begin
   if ( :new.id is null ) then
      select seq_CONTACT_GROUP_ITEMS.nextval into :new.id from dual;
   end if;
end;
---------------------

--CALENDAR_ITEMS

create sequence seq_CALENDAR_ITEMS;
create trigger t_trigger_CALENDAR_ITEMS  before insert on CALENDAR_ITEMS for each row
begin
   if ( :new.id is null ) then
      select seq_CALENDAR_ITEMS.nextval into :new.id from dual;
   end if;
end;
------------------------------------------
create sequence seq_CONTACTS;
create trigger t_trigger_CONTACTS  before insert on CONTACTS for each row
begin
   if ( :new.id is null ) then
      select seq_CONTACTS.nextval into :new.id from dual;
   end if;
end;
-----------------------------------
create sequence seq_EMAIL_DB_ITEMS;
create trigger t_trigger_EMAIL_DB_ITEMS  before insert on EMAIL_DB_ITEMS for each row
begin
   if ( :new.id is null ) then
      select seq_EMAIL_DB_ITEMS.nextval into :new.id from dual;
   end if;
end;
----------------------------------------
--FILTERS
create sequence seq_FILTERS;
create trigger t_trigger_FILTERS  before insert on FILTERS for each row
begin
   if ( :new.id is null ) then
      select seq_FILTERS.nextval into :new.id from dual;
   end if;
end;
-------------------------------------------
create sequence seq_FOLDER_DB_ITEMS;
create trigger t_trigger_FOLDER_DB_ITEMS  before insert on FOLDER_DB_ITEMS for each row
begin
   if ( :new.id is null ) then
      select seq_FOLDER_DB_ITEMS.nextval into :new.id from dual;
   end if;
end;
-----------------------------------------
--NOTES
create sequence seq_NOTES;
create trigger t_trigger_NOTES  before insert on NOTES for each row
begin
   if ( :new.id is null ) then
      select seq_NOTES.nextval into :new.id from dual;
   end if;
end;
-----------------------------------------

--NOTES_FOLDERS
create sequence seq_NOTES_FOLDERS;
create trigger t_trigger_NOTES_FOLDERS  before insert on NOTES_FOLDERS for each row
begin
   if ( :new.id is null ) then
      select seq_NOTES_FOLDERS.nextval into :new.id from dual;
   end if;
end;

-------------------------------------------
--USERSETTINGS
create sequence seq_USERSETTINGS;
create trigger t_trigger_USERSETTINGS  before insert on USERSETTINGS for each row
begin
   if ( :new.id is null ) then
      select seq_USERSETTINGS.nextval into :new.id from dual;
   end if;
end;
