package org.claros.commons.mail.parser;

import java.util.ArrayList;

import org.claros.commons.mail.models.Email;
import org.claros.commons.mail.models.EmailPart;
import org.claros.commons.utility.Utility;

/**
 * @author Umut Gokbayrak
 *
 */
public class HTMLMessageParser {

    /**
     * Default Constructor
     */
    public HTMLMessageParser() {
        super();
    }

	public static String prepareInlineHTMLContent(Email msg, String str) {
		if ((str == null) || (str.equals("")))
			return "";
		int i = -1;
		// cid with double quotes
		String tmp = null;
		String contentId = null;
		int j = -1;
		int partId = -1;
		while ((i=str.indexOf("\"cid:")) != -1) {
			tmp = str.substring(i + 5);
			j = tmp.indexOf("\"");
			contentId = tmp.substring(0, j);
			partId = getPartIdByContentId(msg, contentId);

			str = str.substring(0, i) + "\"showPart.do?partid=" + partId + "\"" + tmp.substring(j + 1);
		}
		return str;
	}

	private static int getPartIdByContentId(Email msg, String cid) {
		ArrayList parts = msg.getParts();
		for (int i=0;i<parts.size();i++) {
			EmailPart part = (EmailPart)parts.get(i);
			String contentId = part.getContentId();
			if (contentId != null && contentId.equals(cid)) {
				return i;
			}
		}
		// still havent found it. maybe cid is surrounded with < > 
		for (int i=0;i<parts.size();i++) {
			EmailPart part = (EmailPart)parts.get(i);
			String contentId = part.getContentId();
			contentId = Utility.extendedTrim(contentId, "<");
			contentId = Utility.extendedTrim(contentId, ">");
			if (contentId != null && contentId.equals(cid)) {
				return i;
			}
		}
		return -1;
	}
}
