package org.claros.groupware.calendar.actions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.claros.commons.exception.NoPermissionException;
import org.claros.commons.models.AuthProfile;
import org.claros.groupware.calendar.controllers.CalendarDBController;
import org.claros.groupware.calendar.models.CalendarItem;
import org.claros.groupware.calendar.models.EventFormBean;
import org.claros.groupware.common.actions.BaseLoggedAction;

/**
 * @version 	1.0
 * @author
 */
public class DeleteEventAction extends BaseLoggedAction {

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		AuthProfile auth = getAuthProfile(request);
		EventFormBean bean = (EventFormBean)getVariable(request, "EventFormBean");
		Long eventId = new Long(bean.getId());
		CalendarItem item = CalendarDBController.getEventById(auth, eventId);
		if (!item.getUser().equals(auth.getUsername())) {
			throw new NoPermissionException();
		}
		CalendarDBController.deleteEvent(auth, eventId);
		
		String calTab = (String)getVariable(request, "calendarTab");
		if (calTab == null || calTab.equals("day")) {
			return mapping.findForward("/listDaily.do");
		} else if (calTab.equals("week")) {
			return mapping.findForward("/listWeekly.do");
		} else if (calTab.equals("month")) {
			return mapping.findForward("/listMonthly.do");
		}
		return mapping.findForward("/listDaily.do");
	}
}
