package org.claros.groupware.calendar.actions;

import java.sql.Timestamp;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.claros.commons.models.AuthProfile;
import org.claros.groupware.calendar.controllers.CalendarDBController;
import org.claros.groupware.calendar.models.CalendarItem;
import org.claros.groupware.calendar.models.EventFormBean;
import org.claros.groupware.common.actions.BaseLoggedAction;

/**
 * @version 	1.0
 * @author		Umut Gkbayrak
 */
public class SaveEventAction extends BaseLoggedAction {

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		EventFormBean bean = (EventFormBean)getVariable(request, "EventFormBean");
		bean.setRecordDate(request.getParameter("recordDate"));
		
		String eventId = bean.getId();
		String category = bean.getCategory();
		String desc = bean.getDescription();
		String recDate = bean.getRecordDate() + ":55.000";
		String remMils = bean.getReminderDays();
		String repeatType = bean.getRepeatType();
		
		AuthProfile auth = getAuthProfile(request);
		CalendarItem item = new CalendarItem();
		item.setCategory(category);
		item.setDescription(desc);
		if (eventId != null && !eventId.equals("")) {
			item.setId(new Long(eventId));
		}
		item.setRecordDate(Timestamp.valueOf(recDate));
		item.setReminderDays(new Integer(remMils));
		item.setRepeatType(new Integer(repeatType));
		item.setUser(auth.getUsername());
		CalendarDBController.saveEvent(auth, item);
		
		return mapping.findForward("/save_result.jsp");
	}
}
