package org.claros.groupware.common.actions;

import java.util.ArrayList;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.claros.commons.exception.ClarosBaseException;
import org.claros.commons.mail.exception.ServerDownException;
import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.utility.Constants;

/**
 * @author Umut Gokbayrak
 */
public abstract class BaseLoggedPopupAction extends BaseClarosAction {
	public abstract ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception;
    
	/* (non-Javadoc)
	 * @see org.apache.struts.action.Action#execute(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		commonFunctions(response);

		ActionForward forward = null;
		try {
			AuthProfile auth = getAuthProfile(request);
			if (auth != null) {
				forward = myExecute(mapping, form, request, response);
			} else {
				request.setAttribute("sessionExpired", new Boolean(true));
				forward = mapping.findForward("/profiling/loginStart.do");
			}
		} catch (ServerDownException e) {
			request.setAttribute("myexception", e.getMessage());
			forward = mapping.findForward("/profiling/loginStart.do");
		} catch (Exception e) {
			ClarosBaseException ce = new ClarosBaseException(e);
			request.setAttribute("myexception", ce);
			forward = mapping.findForward(Constants.GENERALERR);
		}
		return forward;
	}

	public AuthProfile getAuthProfile(HttpServletRequest request) {
		return (AuthProfile)request.getSession().getAttribute("auth");
	}

	public ArrayList getUserSettings(HttpServletRequest request) {
		return (ArrayList)request.getSession().getAttribute("prefs");
	}
}
