package org.claros.groupware.contacts.actions;

import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.actions.BaseLoggedAction;
import org.claros.groupware.contacts.controllers.ContactsController;
import org.claros.groupware.preferences.controllers.UserPrefsController;
import org.claros.groupware.preferences.utility.UserPrefConstants;

/**
 * @version 	1.0
 * @author		Umut Gkbayrak
 */
public class ListContactsAction extends BaseLoggedAction {

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		String letters[] = {"A", "B", "C", "D", "E", "F", "G", "H", "I",
							"J", "K", "L", "M", "N", "O", "P", "Q", "R", 
							"S", "T", "U", "V", "W", "X", "Y", "Z", "0", 
							"1", "2", "3", "4", "5", "6", "7", "8", "9"};
		request.setAttribute("letters", letters);

		String letter = (String)getVariable(request, "l");
		if (letter == null || letter.trim().length() == 0) {
			letter = "A";
		}
		request.setAttribute("letter", letter);
		
		// get the contacts list by letter
		AuthProfile auth = getAuthProfile(request);
		List contacts = ContactsController.getContactsByNamePrefix(auth, letter);
		request.setAttribute("contacts", contacts);

		// determine how to display the fullnames		
		String displayType = UserPrefsController.getUserSetting(auth, UserPrefConstants.displayType);
		boolean nameFirst = true;
		if (displayType != null && displayType.equals(UserPrefConstants.DISPLAY_TYPE_SURNAME_FIRST)) {
			nameFirst = false;
		}
		request.setAttribute("nameFirst", new Boolean(nameFirst));

		return mapping.findForward("/list_contacts.jsp");
	}
}
