package org.claros.groupware.contacts.actions;

import javax.mail.Address;
import javax.mail.internet.InternetAddress;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.claros.commons.mail.utility.Utility;
import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.actions.BaseLoggedAction;
import org.claros.groupware.contacts.models.ContactFormBean;
import org.claros.groupware.preferences.controllers.UserPrefsController;
import org.claros.groupware.preferences.utility.UserPrefConstants;

/**
 * @version 	1.0
 * @author		Umut Gkbayrak
 */
public class NewContactAction extends BaseLoggedAction {

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		AuthProfile auth = getAuthProfile(request);

		// determine how to display the fullnames		
		String displayType = UserPrefsController.getUserSetting(auth, UserPrefConstants.displayType);
		boolean nameFirst = true;
		if (displayType != null && displayType.equals(UserPrefConstants.DISPLAY_TYPE_SURNAME_FIRST)) {
			nameFirst = false;
		}
		request.setAttribute("nameFirst", new Boolean(nameFirst));

		// bir ismi hzl bir ekilde ekliyorsak...
		String pre = (String)getVariable(request, "pre");
		if (pre != null) {
			ContactFormBean bean = new ContactFormBean();
			Address adrs[] = null;
			if (pre.indexOf("@") > 0) {
				adrs = Utility.stringToAddressArray(pre);
			} else {
				bean.setFirstName(pre);
			}
			if (adrs != null && adrs.length > 0) {
				InternetAddress iad = (InternetAddress)adrs[0];
				if (iad.getPersonal() != null) {
					String fullName = iad.getPersonal().trim();
					int lastPos = fullName.lastIndexOf(" ");
					String lastName = "";
					if (lastPos > 0) {
						lastName = fullName.substring(lastPos).trim();
					}
					int firstPos = fullName.indexOf(" ");
					String firstName = fullName;
					if (firstPos > 0) {
						firstName = fullName.substring(0, firstPos).trim();
					}
					String middleName = "";
					if (firstPos != lastPos) {
						middleName = fullName.substring(firstPos, lastPos).trim();
					}
					bean.setFirstName(firstName);
					bean.setLastName(lastName);
					bean.setMiddleName(middleName);
				}
				
				if (iad.getAddress() != null) {
					String email = iad.getAddress().trim();
					bean.setEmailPrimary(email);
				}
			}
			request.setAttribute("ContactFormBean", bean);
		}
		
		return mapping.findForward("/contact.jsp");
	}
}
