package org.claros.groupware.contacts.actions;

import java.sql.Timestamp;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.actions.BaseLoggedAction;
import org.claros.groupware.contacts.controllers.ContactsController;
import org.claros.groupware.contacts.models.Contact;
import org.claros.groupware.contacts.models.ContactFormBean;

/**
 * @version 	1.0
 * @author		Umut Gkbayrak
 */
public class SaveContactAction extends BaseLoggedAction {

	/* (non-Javadoc)
	 * @see org.claros.groupware.common.actions.BaseClarosAction#myExecute(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		ContactFormBean bean = (ContactFormBean)form;

		bean.setAnniversary(request.getParameter("anniversary"));
		bean.setBirthDay(request.getParameter("birthday"));
		
		Contact contact = new Contact();
		if (bean.getAnniversary() != null && bean.getAnniversary().trim().length() > 0) {
			contact.setAnniversary(Timestamp.valueOf(bean.getAnniversary() + " 08:00:00.000"));
		}
		if (bean.getBirthDay() != null && bean.getBirthDay().trim().length() > 0) {
			contact.setBirthDay(Timestamp.valueOf(bean.getBirthDay() + " 08:00:00.000"));
		}
		contact.setEmailAlternate(bean.getEmailAlternative());
		contact.setEmailPrimary(bean.getEmailPrimary());
		contact.setFirstName(bean.getFirstName());
		contact.setGsmNoAlternate(bean.getGsmNoAlternative());
		contact.setGsmNoPrimary(bean.getGsmNoPrimary());
		contact.setHomeAddress(bean.getHomeAddress());
		contact.setHomeCity(bean.getHomeCity());
		contact.setHomeCountry(bean.getHomeCountry());
		contact.setHomeFaks(bean.getHomeFaks());
		contact.setHomePhone(bean.getHomePhone());
		contact.setHomeProvince(bean.getHomeProvince());
		contact.setHomeZip(bean.getHomeZip());
		
		String id = bean.getId();
		if (id != null && id.trim().length() > 0) {
			// it is an update
			try {
				contact.setId(new Long(Long.parseLong(id)));
			} catch (NumberFormatException e) {
				e.printStackTrace();
			}
		}
		contact.setLastName(bean.getLastName());
		contact.setMiddleName(bean.getMiddleName());
		contact.setNickName(bean.getNickName());
		contact.setPersonalNote(bean.getPersonalNote());
		contact.setSex(bean.getSex());
		contact.setSpouseName(bean.getSpouseName());
		contact.setTitle(bean.getTitle());
		
		AuthProfile auth = getAuthProfile(request);
		contact.setUser(auth.getUsername());
		contact.setWebPage(bean.getWebPage());
		contact.setWorkAddress(bean.getWorkAddress());
		contact.setWorkAssistantName(bean.getWorkAssistantName());
		contact.setWorkCity(bean.getWorkCity());
		contact.setWorkFaks(bean.getWorkFaks());
		contact.setWorkJobTitle(bean.getWorkJobTitle());
		contact.setWorkManagerName(bean.getWorkManagerName());
		contact.setWorkOffice(bean.getWorkOffice());
		contact.setWorkPhone(bean.getWorkPhone());
		contact.setWorkProfession(bean.getWorkProfession());
		contact.setWorkProvince(bean.getWorkProvince());
		contact.setWorkZip(bean.getWorkZip());
		contact.setWorkCompany(bean.getWorkCompany());
		contact.setWorkDepartment(bean.getWorkDepartment());
		contact.setWorkCountry(bean.getWorkCountry());
		
		ContactsController.saveContact(auth, contact);
		
		return mapping.findForward("/save_result.jsp");
	}
}
