package org.claros.groupware.filters.actions;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.claros.commons.mail.models.ConnectionMetaHandler;
import org.claros.commons.mail.models.ConnectionProfile;
import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.actions.BaseLoggedAction;
import org.claros.groupware.filters.controllers.FilterController;
import org.claros.groupware.filters.models.Filter;
import org.claros.groupware.filters.models.FilterWrapper;
import org.claros.groupware.webmail.controllers.FolderController;
import org.claros.groupware.webmail.factory.FolderControllerFactory;
import org.claros.groupware.webmail.models.FolderDbItem;

/**
 * @version 	1.0
 * @author		Umut Gkbayrak
 */
public class ListFiltersAction extends BaseLoggedAction {

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		AuthProfile auth = getAuthProfile(request);
		List filters = FilterController.getFilters(auth);
		
		ArrayList wrappers = new ArrayList();
		if (filters != null) {
			Filter tmp = null;
			String sDest = null;
			FolderDbItem fold = null;
			FilterWrapper wrap = null;

			ConnectionMetaHandler handler = getConnectionHandler(request);
			ConnectionProfile profile = getConnectionProfile(request);

			FolderControllerFactory factory = new FolderControllerFactory(auth, profile, handler);
			FolderController foldCont = factory.getFolderController();

			for (int i=0;i<filters.size();i++) {
				tmp = (Filter)filters.get(i);
				wrap = new FilterWrapper(tmp);
				
				sDest = tmp.getDestination();
				if (!sDest.equals("0")) {

					fold = foldCont.getFolder(sDest);
					if (fold != null) {
						wrap.setDestinationName(fold.getFolderName());
					} else {
						wrap.setDestinationName("-");
					}
				} else {
					wrap.setDestinationName("-");
				}
				wrappers.add(wrap);
			}
		}
		request.setAttribute("mailFilters", wrappers);
		return mapping.findForward("/list_filters.jsp");
	}
}
