package org.claros.groupware.filters.models;

import org.claros.groupware.filters.utility.Constants;

/**
 * @author Umut Gokbayrak
 */
public class FilterWrapper extends Filter {
	private String destinationName = null;
	private String actionName = null;
	private String conditionName = null;
	private String portionName = null;

	/**
	 * @param tmp
	 */
	public FilterWrapper(Filter tmp) {
		setAction(tmp.getAction());
		setCondition(tmp.getCondition());
		setDestination(tmp.getDestination());
		setId(tmp.getId());
		setKeyword(tmp.getKeyword());
		setPortion(tmp.getPortion());
		setUser(tmp.getUser());
		
		if (tmp.getAction().equals(Constants.ACTION_DELETE)) {
			setActionName(Constants.ACTION_DELETE_STR);
		} else if (tmp.getAction().equals(Constants.ACTION_MOVE)) {
			setActionName(Constants.ACTION_MOVE_STR);
		}
		
		if (tmp.getCondition().equals(Constants.CONDITION_CONTAINS)) {
			setConditionName(Constants.CONDITION_CONTAINS_STR);
		} else if (tmp.getCondition().equals(Constants.CONDITION_EQUALS)) {
			setConditionName(Constants.CONDITION_EQUALS_STR);
		} else if (tmp.getCondition().equals(Constants.CONDITION_NOT_CONTAINS)) {
			setConditionName(Constants.CONDITION_NOT_CONTAINS_STR);
		}
		
		if (tmp.getPortion().equals(Constants.PORTION_CC)) {
			setPortionName(Constants.PORTION_CC_STR);
		} else if (tmp.getPortion().equals(Constants.PORTION_FROM)) {
			setPortionName(Constants.PORTION_FROM_STR);
		} else if (tmp.getPortion().equals(Constants.PORTION_MESSAGE_BODY)) {
			setPortionName(Constants.PORTION_MESSAGE_BODY_STR);
		} else if (tmp.getPortion().equals(Constants.PORTION_SUBJECT)) {
			setPortionName(Constants.PORTION_SUBJECT_STR);
		} else if (tmp.getPortion().equals(Constants.PORTION_TO)) {
			setPortionName(Constants.PORTION_TO_STR);
		}
	}

	/**
	 * @return
	 */
	public String getDestinationName() {
		return destinationName;
	}

	/**
	 * @param string
	 */
	public void setDestinationName(String string) {
		destinationName = string;
	}

	/**
	 * @return
	 */
	public String getActionName() {
		return actionName;
	}

	/**
	 * @return
	 */
	public String getConditionName() {
		return conditionName;
	}

	/**
	 * @return
	 */
	public String getPortionName() {
		return portionName;
	}

	/**
	 * @param string
	 */
	public void setActionName(String string) {
		actionName = string;
	}

	/**
	 * @param string
	 */
	public void setConditionName(String string) {
		conditionName = string;
	}

	/**
	 * @param string
	 */
	public void setPortionName(String string) {
		portionName = string;
	}

}
