package org.claros.groupware.profiling.actions;

import java.util.Locale;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.codec.binary.Hex;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.claros.commons.auth.MailAuth;
import org.claros.commons.auth.exception.LoginInvalidException;
import org.claros.commons.mail.models.ConnectionMetaHandler;
import org.claros.commons.mail.models.ConnectionProfile;
import org.claros.commons.mail.models.ConnectionProfileList;
import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.actions.BaseClarosAction;
import org.claros.groupware.common.filters.SessionListener;
import org.claros.groupware.profiling.models.LoginFormBean;
import org.claros.groupware.webmail.controllers.FolderController;
import org.claros.groupware.webmail.factory.FolderControllerFactory;
import org.hsqldb.lib.MD5;

/**
 * @version 	1.0
 * @author		Umut Gokbayrak
 */
public class LoginEndAction extends BaseClarosAction {

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		ActionForward forward = mapping.findForward("/profiling/loginStart.do");
		LoginFormBean bean = (LoginFormBean)form;
		
		try {
			if (bean != null && bean.getServer() != null) {
				ConnectionProfile profile = ConnectionProfileList.getProfileByShortName(bean.getServer());
				if (bean.getUsername() != null && bean.getPassword() != null) {
					AuthProfile auth = new AuthProfile();
					auth.setUsername(bean.getUsername());
					auth.setPassword(bean.getPassword());
					ConnectionMetaHandler handler = getConnectionHandler(request);
					handler = MailAuth.authenticate(profile, auth, handler);
					if (handler != null) {
						byte b[] = request.getSession().getId().getBytes();
						SessionListener.addOnlineUser(bean.getUsername(), new String(Hex.encodeHex(MD5.digestBytes(b))).toUpperCase(new Locale("en", "US")));
						
						request.getSession().setAttribute("handler", handler);
						request.getSession().setAttribute("auth", auth);
						request.getSession().setAttribute("profile", profile);

						// create default mailboxes if not exists
						FolderControllerFactory factory = new FolderControllerFactory(auth, profile, handler);
						FolderController foldCont = factory.getFolderController();
						foldCont.createDefaultFolders();
						
						// forward the request
						forward = mapping.findForward("/webmail/mailbox.do");
						return forward;
					}
				}
			}
		} catch (LoginInvalidException e) {
			// do nothing, cause login is invalid. 
		}
		request.setAttribute("loginInvalid", new Boolean(true));
		forward = mapping.findForward("/profiling/loginStart.do");

		return forward;
	}
}
