package org.claros.groupware.webmail.actions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.claros.commons.mail.models.ConnectionMetaHandler;
import org.claros.commons.mail.models.ConnectionProfile;
import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.actions.BaseLoggedAction;
import org.claros.groupware.webmail.controllers.FolderController;
import org.claros.groupware.webmail.factory.FolderControllerFactory;
import org.claros.groupware.webmail.models.ListFoldersFormBean;

/**
 * @version 	1.0
 * @author		Umut Gkbayrak
 */
public class DeleteFolderAction extends BaseLoggedAction {

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		ListFoldersFormBean bean = (ListFoldersFormBean)form;
		String folders[] = bean.getFolders();
		if (folders != null) {
			AuthProfile auth = getAuthProfile(request);

			ConnectionMetaHandler handler = getConnectionHandler(request);
			ConnectionProfile profile = getConnectionProfile(request);

			FolderControllerFactory factory = new FolderControllerFactory(auth, profile, handler);
			FolderController foldCont = factory.getFolderController();

			String id = null;
			for (int i=0;i<folders.length;i++) {
				id = folders[i];
				foldCont.deleteFolder(id);
			}
		}
		
		return mapping.findForward("/foldersEntry.do");
	}
}
