package org.claros.groupware.webmail.actions;

import java.util.HashMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.actions.BaseLoggedAction;
import org.claros.groupware.notes.controllers.NotesController;
import org.claros.groupware.preferences.controllers.UserPrefsController;
import org.claros.groupware.preferences.utility.UserPrefConstants;
import org.claros.groupware.webmail.models.ComposeFormBean;

/**
 * @version 	1.0
 * @author
 */
public class EmailNoteAction extends BaseLoggedAction {

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		AuthProfile auth = getAuthProfile(request);
		HashMap prefMap = UserPrefsController.getUserPreferences(auth);
		String mailFormat = (String)prefMap.get(UserPrefConstants.mailFormat);
		if (mailFormat == null || mailFormat.equals("html")) {
			request.setAttribute("HtmlMail", new Boolean(true));
		} else {
			request.setAttribute("HtmlMail", new Boolean(false));
		}
		
		// get the from address and prepare in a format which is to be shown.
		String fullName = (String)prefMap.get(UserPrefConstants.fullName);
		String from = (String)prefMap.get(UserPrefConstants.fromAddress);
		String fullFromAddress = fullName + " <" + from + ">";
		if (fullName == null || fullName.trim().length() == 0) {
			fullFromAddress = from;
		}
		request.setAttribute("FromAddress", fullFromAddress);

		String note = NotesController.getNoteById(auth, new Long((String)getVariable(request, "noteId"))).getNote();
		
		// delete the previous values
		request.getSession().setAttribute("ComposeFormBean", null);
		request.getSession().setAttribute("attachments", null);

		// now create a new one.
		ComposeFormBean bean = new ComposeFormBean();
		bean.setMessageBody(note);
		request.getSession().setAttribute("ComposeFormBean", bean);
		return mapping.findForward("/compose.jsp");
	}
}
