package org.claros.groupware.webmail.controllers;

import javax.mail.Flags;
import javax.mail.Folder;
import javax.mail.Message;
import javax.mail.internet.MimeMessage;

import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.utility.Constants;
import org.claros.groupware.preferences.controllers.UserPrefsController;
import org.claros.groupware.preferences.utility.UserPrefConstants;
import org.jasen.JasenScanner;
import org.jasen.interfaces.JasenScanResult;

/**
 * @author Umut Gokbayrak
 */
public class SpamController {

	/**
	 * @param auth
	 * @param msg
	 * @return
	 */
	public static boolean isSpam(AuthProfile auth, Message msg) throws Exception {
		System.setProperty("java.awt.headless", "true");
		String spam = UserPrefsController.getUserSetting(auth, UserPrefConstants.spamAnalysis);
		boolean spamAnalysis = false;
		if (spam != null && spam.equals("yes")) {
			spamAnalysis = true;
		}
		if (spamAnalysis) {
			if (msg instanceof MimeMessage) {
				if (Constants.spamScanner == null) {
					JasenScanner.getInstance().init();
					Constants.spamScanner = JasenScanner.getInstance();
				}
				if (!msg.getFolder().isOpen()) {
					msg.getFolder().open(Folder.READ_ONLY);
				}
//				msg = msg.getFolder().getMessage(msg.getMessageNumber());
				JasenScanResult result = Constants.spamScanner.scan((MimeMessage)msg);
				double probability = result.getProbability();
				
				msg.setFlag(Flags.Flag.SEEN, false);
				String accepts = UserPrefsController.getUserSetting(auth, UserPrefConstants.spamUserAccepts);
				Double d = null;
				if (accepts == null) {
					d = new Double(0.9);
				} else {
					d = new Double(accepts);
				}
				if (probability >= d.doubleValue()) {
					// it is spam
					return true;
				} else {
					return false;
				}
			}
		}
		return false;
	}

}
