package org.claros.taglibs.tab;

import java.io.IOException;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.BodyContent;
import javax.servlet.jsp.tagext.BodyTagSupport;

/**
 * @author Umut Gokbayrak
 *
 */
public class TabTag extends BodyTagSupport {
	private String height;
	private String width;
	private String activeClassName;
	private String inactiveClassName;
	private String text;
	private String body;

	/**
	 * 
	 */
	public TabTag() {
		super();
	}

	/**
	 *  
	 * Fill in this method to perform other operations from doStartTag().
	 * 
	 */
	public void otherDoStartTagOperations() {
	}

	public boolean theBodyShouldBeEvaluated() {
		return true;
	}

	/**
	 *  
	 * Fill in this method to perform other operations from doEndTag().
	 * 
	 */
	public void otherDoEndTagOperations() {
		TabViewTag tabTag = (TabViewTag) findAncestorWithClass(this, TabViewTag.class);
		
		tabTag.addTab(new Tab(height, width, activeClassName, inactiveClassName, text, body));
	}

	/**
	 *  
	 * Fill in this method to determine if the rest of the JSP page
	 * should be generated after this tag is finished.
	 * Called from doEndTag().
	 * 
	 */
	public boolean shouldEvaluateRestOfPageAfterEndTag() {
		return true;
	}

	////////////////////////////////////////////////////////////////
	///                                                          ///
	///   Tag Handler interface methods.                         ///
	///                                                          ///
	///   Do not modify these methods; instead, modify the       ///
	///   methods that they call.                                ///
	///                                                          ///
	////////////////////////////////////////////////////////////////

	/** .
	 *
	 * This method is called when the JSP engine encounters the start tag,
	 * after the attributes are processed.
	 * Scripting variables (if any) have their values set here.
	 * @return EVAL_BODY_INCLUDE if the JSP engine should evaluate the tag body, otherwise return SKIP_BODY.
	 * This method is automatically generated. Do not modify this method.
	 * Instead, modify the methods that this method calls.
	 *
	 *
	 */
	public int doStartTag() throws JspException, JspException {
		otherDoStartTagOperations();

		if (theBodyShouldBeEvaluated()) {
			return EVAL_BODY_BUFFERED;
		} else {
			return SKIP_BODY;
		}
	}

	/** .
	 *
	 *
	 * This method is called after the JSP engine finished processing the tag.
	 * @return EVAL_PAGE if the JSP engine should continue evaluating the JSP page, otherwise return SKIP_PAGE.
	 * This method is automatically generated. Do not modify this method.
	 * Instead, modify the methods that this method calls.
	 *
	 *
	 */
	public int doEndTag() throws JspException, JspException {
		otherDoEndTagOperations();

		if (shouldEvaluateRestOfPageAfterEndTag()) {
			return EVAL_PAGE;
		} else {
			return SKIP_PAGE;
		}
	}

	/** .
	 * Fill in this method to process the body content of the tag.
	 * You only need to do this if the tag's BodyContent property
	 * is set to "JSP" or "tagdependent."
	 * If the tag's bodyContent is set to "empty," then this method
	 * will not be called.
	 *
	 *
	 */
	public void writeTagBodyContent(JspWriter out, BodyContent bodyContent)
		throws IOException {
		//
		// TODO: insert code to write html before writing the body content.
		//       e.g.  out.println("<B>" + getAttribute1() + "</B>");
		//             out.println("   <BLOCKQUOTE>");

		//
		// write the body content (after processing by the JSP engine) on the output Writer
		//
		body = bodyContent.getString();

		out.getBufferSize();
//		bodyContent.writeOut(out);

		//
		// Or else get the body content as a string and process it, e.g.:
		//     String bodyStr = bodyContent.getString();
		//     String result = yourProcessingMethod(bodyStr);
		//     out.println(result);
		//

		// TODO: insert code to write html after writing the body content.
		//       e.g.  out.println("   <BLOCKQUOTE>");

		// clear the body content for the next time through.
		bodyContent.clearBody();
	}

	/** .
	 *
	 * Handles exception from processing the body content.
	 *
	 *
	 */
	public void handleBodyContentException(Exception ex) throws JspException {
		// Since the doAfterBody method is guarded, place exception handing code here.
		throw new JspException("error in TreeTag: " + ex);
	}

	/** .
	 *
	 *
	 * This method is called after the JSP engine processes the body content of the tag.
	 * @return EVAL_BODY_AGAIN if the JSP engine should evaluate the tag body again, otherwise return SKIP_BODY.
	 * This method is automatically generated. Do not modify this method.
	 * Instead, modify the methods that this method calls.
	 *
	 *
	 */
	public int doAfterBody() throws JspException {
		try {
			//
			// This code is generated for tags whose bodyContent is "JSP"
			//
			BodyContent bodyContent = getBodyContent();
			JspWriter out = bodyContent.getEnclosingWriter();

			writeTagBodyContent(out, bodyContent);
		} catch (Exception ex) {
			handleBodyContentException(ex);
		}

		if (theBodyShouldBeEvaluatedAgain()) {
			return EVAL_BODY_AGAIN;
		} else {
			return SKIP_BODY;
		}
	}

	/**
	 * Fill in this method to determine if the tag body should be evaluated
	 * again after evaluating the body.
	 * Use this method to create an iterating tag.
	 * Called from doAfterBody().
	 *
	 *
	 */
	public boolean theBodyShouldBeEvaluatedAgain() {
		return false;
	}
	/**
	 * @return
	 */
	public String getActiveClassName() {
		return activeClassName;
	}

	/**
	 * @return
	 */
	public String getHeight() {
		return height;
	}

	/**
	 * @return
	 */
	public String getInactiveClassName() {
		return inactiveClassName;
	}

	/**
	 * @return
	 */
	public String getText() {
		return text;
	}

	/**
	 * @return
	 */
	public String getWidth() {
		return width;
	}

	/**
	 * @param string
	 */
	public void setActiveClassName(String string) {
		activeClassName = string;
	}

	/**
	 * @param string
	 */
	public void setHeight(String string) {
		height = string;
	}

	/**
	 * @param string
	 */
	public void setInactiveClassName(String string) {
		inactiveClassName = string;
	}

	/**
	 * @param string
	 */
	public void setText(String string) {
		text = string;
	}

	/**
	 * @param string
	 */
	public void setWidth(String string) {
		width = string;
	}

}
