package org.claros.taglibs.tab;

import java.io.IOException;
import java.util.ArrayList;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.BodyContent;
import javax.servlet.jsp.tagext.BodyTagSupport;

/**
 * @author Umut Gokbayrak
 *
 */
public class TabViewTag extends BodyTagSupport {
	private String width = "780";
	private String className = "normalTable";
	
	private String activeClassName = "tabactive";
	private String inactiveClassName = "tabinactive";
	private String spaceClassName = "tabspace";

	private String tabBodyActiveClassName = "tabbodyactive";
	private String tabBodyInactiveClassName = "tabbodyinactive";
	private ArrayList tabs;
	
	public TabViewTag() {
		super();
		tabs = new ArrayList();
	}

	public void addTab(Tab tab) {
		tabs.add(tab);
	}

	/**
	 *  
	 * Fill in this method to perform other operations from doStartTag().
	 * 
	 */
	public void otherDoStartTagOperations() {
	}

	public boolean theBodyShouldBeEvaluated() {
		return true;
	}

	/**
	 *  
	 * Fill in this method to perform other operations from doEndTag().
	 * 
	 */
	public void otherDoEndTagOperations() {
		try {
			JspWriter out = pageContext.getOut();

			out.println("<table width='" + width + "' border='0' cellspacing='0' cellpadding='0' class='" + className + "'>");
			out.println("<tr>");

			int tableSize = Integer.parseInt(width);
			int defaultTabSize = (int)Math.floor((double)tableSize / (double)tabs.size());

			Tab tmp = null;
			String tabWidth = null;
			
			String tabInactive = inactiveClassName;
			String tabActive = activeClassName;

			int widthTotal = 0;
			int tmpWidth = 0;
			for (int i=0; i<tabs.size(); i++) {
				tmp = (Tab)tabs.get(i);

				tabWidth = "" + defaultTabSize;
				tabInactive = inactiveClassName;
				tabActive = activeClassName;

				if (tmp.getWidth() != null) {
					tabWidth = tmp.getWidth();
				}
				if (tmp.getActiveClassName() != null) {
					tabActive = tmp.getActiveClassName();
				}
				if (tmp.getInactiveClassName() != null) {
					tabInactive = tmp.getInactiveClassName();
				}
				
				tmpWidth = Integer.parseInt(tabWidth);
				widthTotal += tmpWidth;
				
				if (i == 0) {
					out.println("<td width='" + tabWidth + "' class='" + tabActive + "' onMouseOver='tabHover(this)' onMouseOut='tabUnHover(this)' onClick='tabActive(this)'>" + tmp.getText() + "</td>");
				} else {
					out.println("<td width='" + tabWidth + "' class='" + tabInactive + "' onMouseOver='tabHover(this)' onMouseOut='tabUnHover(this)' onClick='tabActive(this)'>" + tmp.getText() + "</td>");
				}
			}

			int diff = 0;
			if (tmpWidth < tableSize) {
				diff = tableSize - widthTotal;
			}
	
			out.println("<td width='" + diff + "' class='" + spaceClassName + "'><img src='/claros/images/spacer.gif' width='" + diff + "' height='1'></td>");
			out.println("</tr>");
			out.println("</table>");
			
			
			String height = null;
			for (int i=0; i<tabs.size(); i++) {
				tmp = (Tab)tabs.get(i);
				
				height = tmp.getHeight();
				if (height == null || height.trim().length() == 0) {
					height = "300";
				}

				if (i == 0) {
					out.println("<div class='" + tabBodyActiveClassName + "' id='Claros" + tmp.getText() + "'>");
				} else {
					out.println("<div class='" + tabBodyInactiveClassName + "' id='Claros" + tmp.getText() + "'>");
				}
				out.println("<table border='0' height='" + height + "' width='" + (tableSize - 6) + "'>");
				out.println("<tr>");
				out.println("<td valign='top'>" + tmp.getBody() + "</td>");
				out.println("</tr>");
				out.println("</table>");
				out.println("</div>");
			}

		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			tabs = new ArrayList();
		}
	}

	/**
	 *  
	 * Fill in this method to determine if the rest of the JSP page
	 * should be generated after this tag is finished.
	 * Called from doEndTag().
	 * 
	 */
	public boolean shouldEvaluateRestOfPageAfterEndTag() {
		return true;
	}

	////////////////////////////////////////////////////////////////
	///                                                          ///
	///   Tag Handler interface methods.                         ///
	///                                                          ///
	///   Do not modify these methods; instead, modify the       ///
	///   methods that they call.                                ///
	///                                                          ///
	////////////////////////////////////////////////////////////////

	/** .
	 *
	 * This method is called when the JSP engine encounters the start tag,
	 * after the attributes are processed.
	 * Scripting variables (if any) have their values set here.
	 * @return EVAL_BODY_INCLUDE if the JSP engine should evaluate the tag body, otherwise return SKIP_BODY.
	 * This method is automatically generated. Do not modify this method.
	 * Instead, modify the methods that this method calls.
	 *
	 *
	 */
	public int doStartTag() throws JspException, JspException {
		otherDoStartTagOperations();

		if (theBodyShouldBeEvaluated()) {
			return EVAL_BODY_BUFFERED;
		} else {
			return SKIP_BODY;
		}
	}

	/** .
	 *
	 *
	 * This method is called after the JSP engine finished processing the tag.
	 * @return EVAL_PAGE if the JSP engine should continue evaluating the JSP page, otherwise return SKIP_PAGE.
	 * This method is automatically generated. Do not modify this method.
	 * Instead, modify the methods that this method calls.
	 *
	 *
	 */
	public int doEndTag() throws JspException, JspException {
		otherDoEndTagOperations();

		if (shouldEvaluateRestOfPageAfterEndTag()) {
			return EVAL_PAGE;
		} else {
			return SKIP_PAGE;
		}
	}

	/** .
	 * Fill in this method to process the body content of the tag.
	 * You only need to do this if the tag's BodyContent property
	 * is set to "JSP" or "tagdependent."
	 * If the tag's bodyContent is set to "empty," then this method
	 * will not be called.
	 *
	 *
	 */
	public void writeTagBodyContent(JspWriter out, BodyContent bodyContent)
		throws IOException {
		//
		// TODO: insert code to write html before writing the body content.
		//       e.g.  out.println("<B>" + getAttribute1() + "</B>");
		//             out.println("   <BLOCKQUOTE>");

		//
		// write the body content (after processing by the JSP engine) on the output Writer
		//
		bodyContent.writeOut(out);

		//
		// Or else get the body content as a string and process it, e.g.:
		//     String bodyStr = bodyContent.getString();
		//     String result = yourProcessingMethod(bodyStr);
		//     out.println(result);
		//

		// TODO: insert code to write html after writing the body content.
		//       e.g.  out.println("   <BLOCKQUOTE>");

		// clear the body content for the next time through.
		bodyContent.clearBody();
	}

	/** .
	 *
	 * Handles exception from processing the body content.
	 *
	 *
	 */
	public void handleBodyContentException(Exception ex) throws JspException {
		// Since the doAfterBody method is guarded, place exception handing code here.
		throw new JspException("error in TreeTag: " + ex);
	}

	/** .
	 *
	 *
	 * This method is called after the JSP engine processes the body content of the tag.
	 * @return EVAL_BODY_AGAIN if the JSP engine should evaluate the tag body again, otherwise return SKIP_BODY.
	 * This method is automatically generated. Do not modify this method.
	 * Instead, modify the methods that this method calls.
	 *
	 *
	 */
	public int doAfterBody() throws JspException {
		try {
			//
			// This code is generated for tags whose bodyContent is "JSP"
			//
			BodyContent bodyContent = getBodyContent();
			JspWriter out = bodyContent.getEnclosingWriter();

			writeTagBodyContent(out, bodyContent);
		} catch (Exception ex) {
			handleBodyContentException(ex);
		}

		if (theBodyShouldBeEvaluatedAgain()) {
			return EVAL_BODY_AGAIN;
		} else {
			return SKIP_BODY;
		}
	}

	/**
	 * Fill in this method to determine if the tag body should be evaluated
	 * again after evaluating the body.
	 * Use this method to create an iterating tag.
	 * Called from doAfterBody().
	 *
	 *
	 */
	public boolean theBodyShouldBeEvaluatedAgain() {
		//
		// TODO: code that determines whether the tag body should be
		//       evaluated again after processing the tag
		//       should be placed here.
		//       You can use this method to create iterating tags.
		//       Called from the doAfterBody() method.
		//
		return false;
	}

	/**
	 * @return
	 */
	public String getClassName() {
		return className;
	}

	/**
	 * @return
	 */
	public String getWidth() {
		return width;
	}

	/**
	 * @param string
	 */
	public void setClassName(String string) {
		className = string;
	}

	/**
	 * @param string
	 */
	public void setWidth(String string) {
		width = string;
	}

	/**
	 * @return
	 */
	public String getActiveClassName() {
		return activeClassName;
	}

	/**
	 * @return
	 */
	public String getInactiveClassName() {
		return inactiveClassName;
	}

	/**
	 * @return
	 */
	public ArrayList getTabs() {
		return tabs;
	}

	/**
	 * @param string
	 */
	public void setActiveClassName(String string) {
		activeClassName = string;
	}

	/**
	 * @param string
	 */
	public void setInactiveClassName(String string) {
		inactiveClassName = string;
	}

	/**
	 * @param list
	 */
	public void setTabs(ArrayList list) {
		tabs = list;
	}

	/**
	 * @return
	 */
	public String getSpaceClassName() {
		return spaceClassName;
	}

	/**
	 * @param string
	 */
	public void setSpaceClassName(String string) {
		spaceClassName = string;
	}

	/**
	 * @return
	 */
	public String getTabBodyActiveClassName() {
		return tabBodyActiveClassName;
	}

	/**
	 * @return
	 */
	public String getTabBodyInactiveClassName() {
		return tabBodyInactiveClassName;
	}

	/**
	 * @param string
	 */
	public void setTabBodyActiveClassName(String string) {
		tabBodyActiveClassName = string;
	}

	/**
	 * @param string
	 */
	public void setTabBodyInactiveClassName(String string) {
		tabBodyInactiveClassName = string;
	}

}
